
// set giu mode to auto by default
document.plugInfo = {dark: 0};

var chartMustRedraw = false;

function OnArbitraryMessage(msgTag, msgVal) {
  msgVal = atob(msgVal);
  switch (msgTag) {
    case -2:
      document.plugInfo = JSON.parse(msgVal);
      document.getElementById("aboutModal").innerHTML = document.getElementById("aboutModal").innerHTML.replace("{plugInfo.version}", document.plugInfo.version);
      document.getElementById("aboutModal").innerHTML = document.getElementById("aboutModal").innerHTML.replace("{plugInfo.buildDate}", document.plugInfo.buildDate);
      document.getElementById("aboutModal").innerHTML = document.getElementById("aboutModal").innerHTML.replace("{plugInfo.copyright}", document.plugInfo.copyright);
      
      var elements = document.getElementsByClassName("track-name");
      Array.from(elements).forEach((el) => {
        el.innerHTML = document.plugInfo.trackname;
        if(document.plugInfo.trackname == "") {
          el.innerHTML = "Track with no name";
        }
      });
      
      handleUIModeChange(document.plugInfo.dark);
      break;
      
      // presets
      case 200:
         var userPresets = JSON.parse(msgVal);
         
         var presets = document.getElementById("presets");
         presets.innerHTML = "<option disabled><b>Factory Presets</b></option>";
         document.plugInfo.factoryPresets.forEach((preset) => {
             var option = document.createElement("option");
             option.value = preset;
             option.classList.add("factory-preset");
             option.innerHTML = preset;
             presets.appendChild(option);
         });
         var option = document.createElement("option");
         option.disabled = true;
         option.innerHTML = "<b>User Presets</b>";
         presets.appendChild(option);
         userPresets.forEach((preset) => {
             var option = document.createElement("option");
             option.value = preset;
             option.classList.add("user-preset");
             option.innerHTML = preset;
             presets.appendChild(option);
         });
         presets.addEventListener("change", (event) => {
             if(event.target.selectedOptions[0].className == "factory-preset") {
                 SAMFUI(100, ctrlTag = -1, event.target.value);
                 document.querySelector("#loadPresetModal .btn-close").dispatchEvent(new Event("click"));
             } else {
                 SAMFUI(101, ctrlTag = -1, event.target.value);
                 document.querySelector("#loadPresetModal .btn-close").dispatchEvent(new Event("click"));
             }
             console.log(event.target);
         });
       break;
     
    // update freq dispaly
    case 90:
      let data = JSON.parse(msgVal);
      for(var i = 0; i < data["raw"].length; i++) {
        if(typeof document.freqChart.data.datasets[0].data[i] !== 'undefined') {
            
            if(data["raw"][i] > document.freqChart.data.datasets[0].data[i].y) {
                document.freqChart.data.datasets[0].data[i] = {"x":data["freqs"][i], "y":data["raw"][i]};
            }
            if(data["smooth"][i] > document.freqChart.data.datasets[1].data[i].y) {
                document.freqChart.data.datasets[1].data[i] =  {"x":data["freqs"][i], "y":data["smooth"][i]};
            }
            if(document.freqChart.data.datasets[2].data[i].y > data["filters"][i]) {
                document.freqChart.data.datasets[2].data[i] =  {"x":data["freqs"][i], "y":data["filters"][i]};
            }
            
            document.freqChart.data.datasets[3].data[i] = {"x":data["freqs"][i], "y":data["eq"][i]};
            
            if(document.freqChart.data.datasets[0].data[i].y < document.freqChart.data.datasets[1].data[i].y) {
                document.freqChart.data.datasets[0].data[i].y = document.freqChart.data.datasets[1].data[i].y;
            }
        } else {
            document.freqChart.data.datasets[0].data[i] =  {"x":data["freqs"][i], "y":data["raw"][i]};
            document.freqChart.data.datasets[1].data[i] =  {"x":data["freqs"][i], "y":data["smooth"][i]};
            document.freqChart.data.datasets[2].data[i] =  {"x":data["freqs"][i], "y":data["filters"][i]};
            document.freqChart.data.datasets[3].data[i] =  {"x":data["freqs"][i], "y":data["eq"][i]};
        }
        
        //if(Number(lowFreq[i]) >= document.freqChart.data.datasets[0].data[i].y) {
        //  document.freqChart.data.datasets[0].data[i].y = Number(lowFreq[i]);
        //}
      }
      chartMustRedraw = true;
      break;
    
  }
}

function handleUIModeChange(mode) {
  // set dark mode according to preferences
  if(mode == 1) {
    // light  or dark mode
    document.getElementsByTagName('html')[0].setAttribute('data-bs-theme', 'light');
  } else if (mode == 2) {
    // dark mode
    document.getElementsByTagName('html')[0].setAttribute('data-bs-theme', 'dark');
  } else if (mode == 0) {
    // auto mode
    const media = window.matchMedia('(prefers-color-scheme: dark)');
    const scheme = media.matches
      ? 'dark'
      : 'light'
    document.getElementsByTagName('html')[0].setAttribute('data-bs-theme', scheme);
  }
  document.freqChart.options.scales.xAxes[0].gridLines.color = window.getComputedStyle(document.body).getPropertyValue('--bs-secondary-bg');
  document.freqChart.options.scales.yAxes[0].gridLines.color = window.getComputedStyle(document.body).getPropertyValue('--bs-secondary-bg');

}


addEventListener('ControlSetup', (event) => {

  addEventListener('ControlChange', (event)=> {
    GetControlByMessageId(event.detail.tag).forEach(function(elem){
      elem.setValue(event.detail.value);
    });
  });
  
  // save original ui proportions
  document.uiratio = document.documentElement.clientWidth / document.documentElement.clientHeight;
  document.uiminwidth = document.documentElement.clientWidth / 2;
  document.uimaxwidth = document.documentElement.clientWidth * 2;
  
  // attach window resizer
  var resizeCtrl = document.createElement('div');
  resizeCtrl.style.cssText = "position:absolute;right:0px;bottom:0px;width:48px;height:48px;border-bottom:8px solid rgb(255,205,67);border-right:8px solid rgb(255,205,67);";
  document.resizeTs = Date.now();
  function dragResize(event) {
    var msg = {};
    msg.x = event.clientX;
    if(msg.x < document.uiminwidth) msg.x = document.uiminwidth;
    if(msg.x > document.uimaxwidth) msg.x = document.uimaxwidth;
    msg.y = msg.x/document.uiratio;
    if(Date.now() - document.resizeTs > 100) {
      document.resizeTs = Date.now();
      SAMFUI(-99, -1, JSON.stringify(msg));
    }
  }
  
  resizeCtrl.addEventListener("pointerdown", function(event){
    event.target.addEventListener("pointermove", dragResize);
    event.target.setPointerCapture(event.pointerId);
  });
  resizeCtrl.addEventListener("pointerup", function(event) {
    event.target.removeEventListener("pointermove", dragResize);
    event.target.releasePointerCapture(event.pointerId);
  });
  resizeCtrl.addEventListener("mouseover", function(event){
    event.target.style.cursor = "nwse-resize";
  });
  resizeCtrl.addEventListener("mouseout", function(event){
    event.target.style.cursor = "initial";
  });
  document.body.appendChild(resizeCtrl);
    
  // save preset action
  document.getElementById('savePresetModalOk').addEventListener('click', (event)=> {
    SAMFUI(102,-1,document.getElementById('presetName').value);
  });

  // handle color theme change from dark to light
  const media = window.matchMedia("(prefers-color-scheme: dark)");
  media.addListener(function(){
    handleUIModeChange(document.plugInfo.dark);
  });
  
  setInterval(function() {
    if(chartMustRedraw == true) {
      document.freqChart.data.datasets[0].backgroundColor = window.getComputedStyle(document.body).getPropertyValue('--raw-chart-color');
      document.freqChart.data.datasets[1].backgroundColor = window.getComputedStyle(document.body).getPropertyValue('--smooth-chart-color');
      document.freqChart.data.datasets[2].backgroundColor = window.getComputedStyle(document.body).getPropertyValue('--filters-color');
      document.freqChart.data.datasets[3].borderColor = window.getComputedStyle(document.body).getPropertyValue('--eq-color');
      
      document.freqChart.update();
      for (var i =0; i < document.freqChart.data.datasets[0].data.length; i++) {
        document.freqChart.data.datasets[0].data[i].y -=1;
        document.freqChart.data.datasets[1].data[i].y -=1;
        document.freqChart.data.datasets[2].data[i].y = 0;
      }
      
      chartMustRedraw = false;
    }
  }, 42);
  
  // update graphical display of operative range
  GetControlByParamId(1)[0].setChangeCallback(function(value) {
    GetControlByParamId(2)[0].getDomElement().min = Number(value);
    document.freqChart.data.datasets[4].data[2].x = value;
    document.freqChart.data.datasets[4].data[3].x = value;
  });
  
  GetControlByParamId(2)[0].setChangeCallback(function(value) {
    GetControlByParamId(1)[0].getDomElement().max = Number(value);
    document.freqChart.data.datasets[5].data[0].x = value;
    document.freqChart.data.datasets[5].data[1].x = value;
  });

  // send chart limits to control point eqs
  for(var i = 0; i < controls.length; i++) {
    if (controls[i].constructor.name == "ieqcontrol") {
        controls[i].setXAxisPxLimits(document.freqChart.scales["x-axis-0"].getPixelForValue(20), document.freqChart.scales["x-axis-0"].getPixelForValue(20000));
        controls[i].setYAxisPxLimits(document.freqChart.scales["B"].getPixelForValue(-18), document.freqChart.scales["B"].getPixelForValue(18));
    }
  }
  
  document.getElementById("ctrleq1").addEventListener("mouseover", function(event){
    bootstrap.Tab.getOrCreateInstance(document.getElementById("pills-low-tab")).show();
  });
  
  document.getElementById("ctrleq2").addEventListener("mouseover", function(event){
    bootstrap.Tab.getOrCreateInstance(document.getElementById("pills-lowmid-tab")).show();
  });
  
  document.getElementById("ctrleq3").addEventListener("mouseover", function(event){
    bootstrap.Tab.getOrCreateInstance(document.getElementById("pills-highmid-tab")).show();
  });
  
  document.getElementById("ctrleq4").addEventListener("mouseover", function(event){
    bootstrap.Tab.getOrCreateInstance(document.getElementById("pills-high-tab")).show();
  });
  
  // resize ui if the monitor is too small
  if(screen.height < 900) {
    var msg = {};
    msg.x = 800;
    msg.y = 600;
    SAMFUI(-99, -1, JSON.stringify(msg));
  }
  
});

document.getElementById('aboutModal').addEventListener('shown.bs.modal', function () {
  
  // set mode droptown to current value
  document.getElementById("dark").value = document.plugInfo.dark;
  
  function updatePreferences() {

    // Create an object to hold the name/value pairs
    const pairs = {
      dark: document.getElementById("dark").value,
    };
    // Return the JSON string
    SAMFUI(999,-1,JSON.stringify(pairs));
  }
  
  // listen color mode change from preferences ui
  document.getElementById("dark").addEventListener("change", function() {
    handleUIModeChange(this.value);
    updatePreferences();
  });
});
